diff --git a/third_party/WebKit/Source/core/events/EventDispatcher.cpp b/third_party/WebKit/Source/core/events/EventDispatcher.cpp
index 8aa5627b6d96..dd9b78287a08 100644
--- a/third_party/WebKit/Source/core/events/EventDispatcher.cpp
+++ b/third_party/WebKit/Source/core/events/EventDispatcher.cpp
@@ -30,6 +30,7 @@
 #include "core/dom/ContainerNode.h"
 #include "core/dom/Document.h"
 #include "core/dom/Element.h"
+#include "core/dom/ClientRect.h"
 #include "core/events/EventDispatchMediator.h"
 #include "core/events/MouseEvent.h"
 #include "core/events/ScopedEventQueue.h"
@@ -43,6 +44,12 @@
 #include "core/inspector/InspectorTraceEvents.h"
 #include "platform/EventDispatchForbiddenScope.h"
 #include "platform/instrumentation/tracing/TraceEvent.h"
+#include "public/web/WebFrameClient.h"
+#include "web/WebFrameWidgetImpl.h"
+#include "web/WebLocalFrameImpl.h"
+#include "core/page/Page.h"
+#include "base/strings/string_piece.h"
+#include "url/gurl.h"
 #include "platform/wtf/RefPtr.h"
 
 namespace blink {
@@ -130,6 +137,37 @@ DispatchEventResult EventDispatcher::Dispatch() {
   TRACE_EVENT0(TRACE_DISABLED_BY_DEFAULT("blink.debug"),
                "EventDispatcher::dispatch");
 
+  // Consider moving this somewhere else to speed up
+  HashSet<String>* whitelisted_events = new HashSet<String>();
+  whitelisted_events->insert("readystatechange");
+  whitelisted_events->insert("DOMActivate");
+  whitelisted_events->insert("DOMContentLoaded");
+  whitelisted_events->insert("load"); // Should this be whitelisted?
+
+  if (!whitelisted_events->Contains(event_->type()) && Document::isExtensionAction()) {
+    bool sensitiveElement = false;
+    AtomicString message = "dispatch a \"" + event_->type() + "\" event";
+    if (GetNode().IsElementNode()) {
+        sensitiveElement = ToElement(GetNode()).isSensitive();
+        if (ToElement(GetNode()).hasDescription()) {
+          message = message + " on a " + "\"" + ToElement(GetNode()).getDescription() + "\"";
+        }
+    }
+    if (!Document::eligibleExtensionAction(&(view_->GetFrame()),
+                                           message,
+                                           *(new String()),
+                                           SuspiciousExtensionAction::EVENT,
+                                           sensitiveElement ?
+                                            SensitiveElement::SENSITIVE :
+                                            SensitiveElement::NOT_SENSITIVE
+                                          )) {
+      return DispatchEventResult::kCanceledBeforeDispatch;
+    }
+  }
+
+  // Delete HashSet
+  delete whitelisted_events;
+
 #if DCHECK_IS_ON()
   DCHECK(!event_dispatched_);
   event_dispatched_ = true;
diff --git a/third_party/WebKit/Source/core/frame/DOMTimer.cpp b/third_party/WebKit/Source/core/frame/DOMTimer.cpp
index 40d6a6c3a2f4..ab91762e69cd 100644
--- a/third_party/WebKit/Source/core/frame/DOMTimer.cpp
+++ b/third_party/WebKit/Source/core/frame/DOMTimer.cpp
@@ -81,6 +81,12 @@ DOMTimer::DOMTimer(ExecutionContext* context,
       timeout_id_(timeout_id),
       nesting_level_(context->Timers()->TimerNestingLevel() + 1),
       action_(action) {
+  // Store the creating worldId, as the timer is fired in the main world.
+  ASSERT(v8::Isolate::GetCurrent()->InContext());
+  origin_world_ = PassRefPtr<DOMWrapperWorld>(DOMWrapperWorld::Current(
+    v8::Isolate::GetCurrent()).GetOriginWorld()
+  );
+
   ASSERT(timeout_id > 0);
   if (ShouldForwardUserGesture(interval, nesting_level_)) {
     // Thread safe because shouldForwardUserGesture will only return true if
@@ -139,6 +145,8 @@ void DOMTimer::Fired() {
   // Only the first execution of a multi-shot timer should get an affirmative
   // user gesture indicator.
   UserGestureIndicator gesture_indicator(std::move(user_gesture_token_));
+  // Ensure the origin world is propagated to the action and is reset afterwards.
+  DOMWrapperWorld::OriginWorldScope worldScope(origin_world_);
 
   TRACE_EVENT1("devtools.timeline", "TimerFire", "data",
                InspectorTimerFireEvent::Data(context, timeout_id_));
diff --git a/third_party/WebKit/Source/core/frame/DOMTimer.h b/third_party/WebKit/Source/core/frame/DOMTimer.h
index 1109819b1a2a..a5fc27e354a5 100644
--- a/third_party/WebKit/Source/core/frame/DOMTimer.h
+++ b/third_party/WebKit/Source/core/frame/DOMTimer.h
@@ -89,6 +89,7 @@ class CORE_EXPORT DOMTimer final : public GarbageCollectedFinalized<DOMTimer>,
   int nesting_level_;
   Member<ScheduledAction> action_;
   RefPtr<UserGestureToken> user_gesture_token_;
+  RefPtr<DOMWrapperWorld> origin_world_;
 };
 
 }  // namespace blink
diff --git a/third_party/WebKit/Source/core/loader/EmptyClients.h b/third_party/WebKit/Source/core/loader/EmptyClients.h
index f5253cbfca6e..9d4f4ecc702b 100644
--- a/third_party/WebKit/Source/core/loader/EmptyClients.h
+++ b/third_party/WebKit/Source/core/loader/EmptyClients.h
@@ -163,6 +163,16 @@ class CORE_EXPORT EmptyChromeClient : public ChromeClient {
     return false;
   }
 
+  bool DisplayExtensionActionPromptDelegate(
+    const GURL&,
+    LocalFrame*,
+    const String&,
+    const SuspiciousExtensionAction&,
+    const SensitiveElement&
+  ) override {
+    return true;
+  }
+  
   bool HasOpenedPopup() const override { return false; }
   PopupMenu* OpenPopupMenu(LocalFrame&, HTMLSelectElement&) override;
   PagePopup* OpenPagePopup(PagePopupClient*) override { return nullptr; }
diff --git a/third_party/WebKit/Source/core/loader/NavigationScheduler.cpp b/third_party/WebKit/Source/core/loader/NavigationScheduler.cpp
index 8a421693d8e5..103b96bbe023 100644
--- a/third_party/WebKit/Source/core/loader/NavigationScheduler.cpp
+++ b/third_party/WebKit/Source/core/loader/NavigationScheduler.cpp
@@ -166,16 +166,25 @@ class ScheduledURLNavigation : public ScheduledNavigation {
                             is_location_change),
         url_(url),
         should_check_main_world_content_security_policy_(
-            kCheckContentSecurityPolicy) {
+            kCheckContentSecurityPolicy),
+        origin_world_(nullptr) {
     if (ContentSecurityPolicy::ShouldBypassMainWorld(origin_document)) {
       should_check_main_world_content_security_policy_ =
           kDoNotCheckContentSecurityPolicy;
     }
+    // Store the world id of the frame requesting the navigation in case it's a 'javascript:...' url.
+    if (v8::Isolate::GetCurrent()->InContext()) {
+      origin_world_ = PassRefPtr<DOMWrapperWorld>(
+        DOMWrapperWorld::Current(v8::Isolate::GetCurrent()).GetOriginWorld()
+      );
+    }
   }
 
   void Fire(LocalFrame* frame) override {
     std::unique_ptr<UserGestureIndicator> gesture_indicator =
         CreateUserGestureIndicator();
+    // Ensure the origin world gets propagated to the navigation and is reset afterwards.
+    DOMWrapperWorld::OriginWorldScope worldScope(origin_world_);
     FrameLoadRequest request(OriginDocument(), ResourceRequest(url_), "_self",
                              should_check_main_world_content_security_policy_);
     request.SetReplacesCurrentItem(ReplacesCurrentItem());
@@ -194,6 +203,7 @@ class ScheduledURLNavigation : public ScheduledNavigation {
   KURL url_;
   ContentSecurityPolicyDisposition
       should_check_main_world_content_security_policy_;
+  RefPtr<DOMWrapperWorld> origin_world_;
 };
 
 class ScheduledRedirect final : public ScheduledURLNavigation {
diff --git a/third_party/WebKit/Source/core/page/ChromeClient.cpp b/third_party/WebKit/Source/core/page/ChromeClient.cpp
index de6af36341fd..b834c7311c9a 100644
--- a/third_party/WebKit/Source/core/page/ChromeClient.cpp
+++ b/third_party/WebKit/Source/core/page/ChromeClient.cpp
@@ -35,6 +35,7 @@
 #include "platform/geometry/IntRect.h"
 #include "platform/network/NetworkHints.h"
 #include "public/platform/WebScreenInfo.h"
+#include <algorithm>
 
 namespace blink {
 
@@ -159,6 +160,25 @@ bool ChromeClient::OpenJavaScriptPrompt(LocalFrame* frame,
       });
 }
 
+bool ChromeClient::DisplayExtensionActionPrompt(const GURL& extension_url,
+                                                LocalFrame* frame,
+                                                const String& message,
+                                                const SuspiciousExtensionAction& extension_action,
+                                                const SensitiveElement& sensitive_element) {
+  ASSERT(frame);
+  // Suspend pages in case the client method runs a new event loop that would
+  // otherwise cause the load to continue while we're in the middle of
+  // executing JavaScript.
+  ScopedPageSuspender suspender;
+  return DisplayExtensionActionPromptDelegate(
+    extension_url,
+    frame,
+    message,
+    extension_action,
+    sensitive_element
+  );
+}
+
 void ChromeClient::MouseDidMoveOverElement(LocalFrame& frame,
                                            const HitTestResult& result) {
   if (!result.GetScrollbar() && result.InnerNode() &&
diff --git a/third_party/WebKit/Source/core/page/ChromeClient.h b/third_party/WebKit/Source/core/page/ChromeClient.h
index 303c656e9428..ece4cea5b5c7 100644
--- a/third_party/WebKit/Source/core/page/ChromeClient.h
+++ b/third_party/WebKit/Source/core/page/ChromeClient.h
@@ -45,6 +45,8 @@
 #include "public/platform/WebDragOperation.h"
 #include "public/platform/WebEventListenerProperties.h"
 #include "public/platform/WebFocusType.h"
+#include <memory>
+#include "url/gurl.h"
 
 // To avoid conflicts with the CreateWindow macro from the Windows SDK...
 #undef CreateWindow
@@ -183,6 +185,13 @@ class CORE_EXPORT ChromeClient : public PlatformChromeClient {
                             const String& message,
                             const String& default_value,
                             String& result);
+  bool DisplayExtensionActionPrompt(
+    const GURL&,
+    LocalFrame*,
+    const String&,
+    const SuspiciousExtensionAction&,
+    const SensitiveElement&
+  );
   virtual void SetStatusbarText(const String&) = 0;
   virtual bool TabsToLinks() = 0;
 
@@ -386,6 +395,12 @@ class CORE_EXPORT ChromeClient : public PlatformChromeClient {
                                             const String& message,
                                             const String& default_value,
                                             String& result) = 0;
+  virtual bool DisplayExtensionActionPromptDelegate(
+    const GURL&,
+    LocalFrame*,
+    const String&,
+    const SuspiciousExtensionAction&,
+    const SensitiveElement&) = 0;
   virtual void PrintDelegate(LocalFrame*) = 0;
 
  private:
diff --git a/third_party/WebKit/Source/core/xmlhttprequest/XMLHttpRequest.cpp b/third_party/WebKit/Source/core/xmlhttprequest/XMLHttpRequest.cpp
index 561ff2d1b3e1..1b13dd732e75 100644
--- a/third_party/WebKit/Source/core/xmlhttprequest/XMLHttpRequest.cpp
+++ b/third_party/WebKit/Source/core/xmlhttprequest/XMLHttpRequest.cpp
@@ -24,6 +24,8 @@
 #include "core/xmlhttprequest/XMLHttpRequest.h"
 
 #include <memory>
+#include <set>
+
 #include "bindings/core/v8/ArrayBufferOrArrayBufferViewOrBlobOrDocumentOrStringOrFormDataOrURLSearchParams.h"
 #include "bindings/core/v8/ArrayBufferOrArrayBufferViewOrBlobOrUSVString.h"
 #include "bindings/core/v8/ExceptionState.h"
@@ -81,8 +83,8 @@
 #include "platform/wtf/Assertions.h"
 #include "platform/wtf/AutoReset.h"
 #include "platform/wtf/StdLibExtras.h"
-#include "platform/wtf/text/CString.h"
 #include "public/platform/WebURLRequest.h"
+#include "platform/wtf/HashSet.h"
 
 namespace blink {
 
@@ -253,7 +255,8 @@ XMLHttpRequest::XMLHttpRequest(
       downloading_to_file_(false),
       response_text_overflow_(false),
       send_flag_(false),
-      response_array_buffer_failure_(false) {}
+      response_array_buffer_failure_(false),
+      can_extension_read_response_(ReadResponsePermission::kPromptUser) {}
 
 XMLHttpRequest::~XMLHttpRequest() {}
 
@@ -273,6 +276,13 @@ XMLHttpRequest::State XMLHttpRequest::readyState() const {
 }
 
 ScriptString XMLHttpRequest::responseText(ExceptionState& exception_state) {
+  if (!CanExtensionReadResponse()) {
+    exception_state.ThrowSecurityError(
+        "Refused to read response from '" + url_.ElidedString() +
+        "' because a user has prevented it.");
+    return ScriptString();
+  }
+
   if (response_type_code_ != kResponseTypeDefault &&
       response_type_code_ != kResponseTypeText) {
     exception_state.ThrowDOMException(kInvalidStateError,
@@ -321,6 +331,13 @@ void XMLHttpRequest::InitResponseDocument() {
 }
 
 Document* XMLHttpRequest::responseXML(ExceptionState& exception_state) {
+  if (!CanExtensionReadResponse()) {
+    exception_state.ThrowSecurityError(
+        "Refused to read response from '" + url_.ElidedString() +
+        "' because a user has prevented it.");
+    return nullptr;
+  }
+
   if (response_type_code_ != kResponseTypeDefault &&
       response_type_code_ != kResponseTypeDocument) {
     exception_state.ThrowDOMException(kInvalidStateError,
@@ -478,6 +495,10 @@ void XMLHttpRequest::setResponseType(const String& response_type,
 }
 
 String XMLHttpRequest::responseType() {
+  if (!CanExtensionReadResponse()) {
+    return "";
+  }
+
   switch (response_type_code_) {
     case kResponseTypeDefault:
       return "";
@@ -496,6 +517,10 @@ String XMLHttpRequest::responseType() {
 }
 
 String XMLHttpRequest::responseURL() {
+  if (!CanExtensionReadResponse()) {
+    return "";
+  }
+
   KURL response_url(response_.Url());
   if (!response_url.IsNull())
     response_url.RemoveFragmentIdentifier();
@@ -520,6 +545,7 @@ void XMLHttpRequest::TrackProgress(long long length) {
 
 void XMLHttpRequest::ChangeState(State new_state) {
   if (state_ != new_state) {
+    can_extension_read_response_ = ReadResponsePermission::kPromptUser;
     state_ = new_state;
     DispatchReadyStateChangeEvent();
   }
@@ -754,7 +780,11 @@ void XMLHttpRequest::send(Document* document, ExceptionState& exception_state) {
   DCHECK(document);
 
   if (!InitSend(exception_state))
-    return;
+      return;
+
+  VLOG(1) << "send() Document";
+  if (!XMLHttpRequest::CanSend(document->xmlEncoding(), exception_state))
+      return;
 
   RefPtr<EncodedFormData> http_body;
 
@@ -781,6 +811,10 @@ void XMLHttpRequest::send(const String& body, ExceptionState& exception_state) {
   if (!InitSend(exception_state))
     return;
 
+  VLOG(1) << "send() String";
+  if (!XMLHttpRequest::CanSend(body, exception_state))
+      return;
+
   RefPtr<EncodedFormData> http_body;
 
   if (!body.IsNull() && AreMethodAndURLValidForSend()) {
@@ -798,6 +832,11 @@ void XMLHttpRequest::send(Blob* body, ExceptionState& exception_state) {
   if (!InitSend(exception_state))
     return;
 
+  VLOG(1) << "send() Blob";
+  // TODO
+  if (!XMLHttpRequest::CanSend(*(new String()), exception_state))
+      return;
+
   RefPtr<EncodedFormData> http_body;
 
   if (AreMethodAndURLValidForSend()) {
@@ -833,6 +872,11 @@ void XMLHttpRequest::send(FormData* body, ExceptionState& exception_state) {
   if (!InitSend(exception_state))
     return;
 
+  VLOG(1) << "send() FormData";
+  // TODO
+  if (!XMLHttpRequest::CanSend(*(new String()), exception_state))
+      return;
+
   RefPtr<EncodedFormData> http_body;
 
   if (AreMethodAndURLValidForSend()) {
@@ -858,6 +902,11 @@ void XMLHttpRequest::send(URLSearchParams* body,
   if (!InitSend(exception_state))
     return;
 
+  VLOG(1) << "send() URLSearchParams";
+  // TODO
+  if (!XMLHttpRequest::CanSend(*(new String()), exception_state))
+      return;
+
   RefPtr<EncodedFormData> http_body;
 
   if (AreMethodAndURLValidForSend()) {
@@ -873,6 +922,11 @@ void XMLHttpRequest::send(DOMArrayBuffer* body,
                           ExceptionState& exception_state) {
   NETWORK_DVLOG(1) << this << " send() ArrayBuffer " << body;
 
+  VLOG(1) << "send() ArrayBuffer";
+  // TODO
+  if (!XMLHttpRequest::CanSend(*(new String()), exception_state))
+      return;
+
   SendBytesData(body->Data(), body->ByteLength(), exception_state);
 }
 
@@ -880,6 +934,11 @@ void XMLHttpRequest::send(DOMArrayBufferView* body,
                           ExceptionState& exception_state) {
   NETWORK_DVLOG(1) << this << " send() ArrayBufferView " << body;
 
+  VLOG(1) << "send() ArrayBufferView";
+  // TODO
+  if (!XMLHttpRequest::CanSend(*(new String()), exception_state))
+      return;
+
   SendBytesData(body->BaseAddress(), body->byteLength(), exception_state);
 }
 
@@ -1375,7 +1434,11 @@ const AtomicString& XMLHttpRequest::GetRequestHeader(
   return request_headers_.Get(name);
 }
 
-String XMLHttpRequest::getAllResponseHeaders() const {
+String XMLHttpRequest::getAllResponseHeaders() {
+  if (!CanExtensionReadResponse()) {
+    return "";
+  }
+
   if (state_ < kHeadersReceived || error_)
     return "";
 
@@ -1414,7 +1477,11 @@ String XMLHttpRequest::getAllResponseHeaders() const {
 }
 
 const AtomicString& XMLHttpRequest::getResponseHeader(
-    const AtomicString& name) const {
+    const AtomicString& name) {
+  if (!CanExtensionReadResponse()) {
+    return g_null_atom;
+  }
+
   if (state_ < kHeadersReceived || error_)
     return g_null_atom;
 
@@ -1485,7 +1552,11 @@ bool XMLHttpRequest::ResponseIsHTML() const {
   return DeprecatedEqualIgnoringCase(FinalResponseMIMEType(), "text/html");
 }
 
-int XMLHttpRequest::status() const {
+int XMLHttpRequest::status() {
+  if (!CanExtensionReadResponse()) {
+    return -1;
+  }
+
   if (state_ == kUnsent || state_ == kOpened || error_)
     return 0;
 
@@ -1495,7 +1566,11 @@ int XMLHttpRequest::status() const {
   return 0;
 }
 
-String XMLHttpRequest::statusText() const {
+String XMLHttpRequest::statusText() {
+  if (!CanExtensionReadResponse()) {
+    return "";
+  }
+
   if (state_ == kUnsent || state_ == kOpened || error_)
     return String();
 
@@ -1872,6 +1947,52 @@ ExecutionContext* XMLHttpRequest::GetExecutionContext() const {
   return SuspendableObject::GetExecutionContext();
 }
 
+bool XMLHttpRequest::CanExtensionReadResponse() {
+  if (can_extension_read_response_ != ReadResponsePermission::kPromptUser) {
+    return can_extension_read_response_ == ReadResponsePermission::kAllow;
+  }
+
+  AtomicString message = "read a network response to " + url_.GetString();
+  bool eligible_extension_action =  Document::eligibleExtensionAction(
+    GetDocument()->GetFrame(),
+    message,
+    *(new String()),
+    SuspiciousExtensionAction::NETWORK_RESPONSE,
+    SensitiveElement::NOT_APPLICABLE
+  );
+  can_extension_read_response_ = eligible_extension_action ?
+                                 ReadResponsePermission::kAllow :
+                                 ReadResponsePermission::kDisallow;
+  return eligible_extension_action;
+}
+
+bool XMLHttpRequest::CanSend(String data, ExceptionState& exception_state) {
+  bool is_sensitive = false;
+  for (HashSet<String>::iterator it = Element::SensitiveData().begin() ;
+       it != Element::SensitiveData().end();
+       ++it) {
+    if (data.Contains(*it, TextCaseSensitivity::kTextCaseUnicodeInsensitive)) {
+      is_sensitive = true;
+      break;
+    }
+  }
+
+  AtomicString message = "send a network request to \"" + url_.GetString() + "\"";
+  if (!Document::eligibleExtensionAction(
+      GetDocument()->GetFrame(),
+      message,
+      *(new String()),
+      SuspiciousExtensionAction::NETWORK_REQUEST,
+      is_sensitive? SensitiveElement::SENSITIVE : SensitiveElement::NOT_APPLICABLE
+  )) {
+      exception_state.ThrowSecurityError(
+          "Refused to connect to '" + url_.ElidedString() +
+          "' because a user has prevented it.");
+      return false;
+  }
+  return true;
+}
+
 DEFINE_TRACE(XMLHttpRequest) {
   visitor->Trace(response_blob_);
   visitor->Trace(loader_);
diff --git a/third_party/WebKit/Source/core/xmlhttprequest/XMLHttpRequest.h b/third_party/WebKit/Source/core/xmlhttprequest/XMLHttpRequest.h
index a4157e850438..1ef4e345ce50 100644
--- a/third_party/WebKit/Source/core/xmlhttprequest/XMLHttpRequest.h
+++ b/third_party/WebKit/Source/core/xmlhttprequest/XMLHttpRequest.h
@@ -118,8 +118,8 @@ class XMLHttpRequest final : public XMLHttpRequestEventTarget,
 
   // JavaScript attributes and methods
   const KURL& Url() const { return url_; }
-  String statusText() const;
-  int status() const;
+  String statusText();
+  int status();
   State readyState() const;
   bool withCredentials() const { return include_credentials_; }
   void setWithCredentials(bool, ExceptionState&);
@@ -143,8 +143,8 @@ class XMLHttpRequest final : public XMLHttpRequestEventTarget,
                         const AtomicString& value,
                         ExceptionState&);
   void overrideMimeType(const AtomicString& override, ExceptionState&);
-  String getAllResponseHeaders() const;
-  const AtomicString& getResponseHeader(const AtomicString&) const;
+  String getAllResponseHeaders();
+  const AtomicString& getResponseHeader(const AtomicString&);
   ScriptString responseText(ExceptionState&);
   ScriptString ResponseJSONSource();
   Document* responseXML(ExceptionState&);
@@ -285,6 +285,16 @@ class XMLHttpRequest final : public XMLHttpRequestEventTarget,
 
   XMLHttpRequestProgressEventThrottle& ProgressEventThrottle();
 
+  enum ReadResponsePermission {
+    kPromptUser, // Ask user if extension has permission to read response
+    kAllow, // Allow an extension to read the response without asking user
+    kDisallow, // Disallow an extension to read the response without asking user
+  };
+
+  bool CanExtensionReadResponse();
+
+  bool CanSend(String data, ExceptionState& exception_state);
+
   Member<XMLHttpRequestUpload> upload_;
 
   KURL url_;
@@ -356,6 +366,8 @@ class XMLHttpRequest final : public XMLHttpRequestEventTarget,
   bool response_text_overflow_;
   bool send_flag_;
   bool response_array_buffer_failure_;
+
+  ReadResponsePermission can_extension_read_response_;
 };
 
 std::ostream& operator<<(std::ostream&, const XMLHttpRequest*);
diff --git a/third_party/WebKit/Source/platform/bindings/DOMWrapperWorld.cpp b/third_party/WebKit/Source/platform/bindings/DOMWrapperWorld.cpp
index 63623c5a7468..b5b63deeaab8 100644
--- a/third_party/WebKit/Source/platform/bindings/DOMWrapperWorld.cpp
+++ b/third_party/WebKit/Source/platform/bindings/DOMWrapperWorld.cpp
@@ -68,6 +68,12 @@ PassRefPtr<DOMWrapperWorld> DOMWrapperWorld::Create(v8::Isolate* isolate,
   return AdoptRef(new DOMWrapperWorld(isolate, world_type, world_id));
 }
 
+Vector<RefPtr<DOMWrapperWorld>>& DOMWrapperWorld::GetOriginWorldStack() {
+  ASSERT(IsMainThread());
+  DEFINE_STATIC_LOCAL(Vector<RefPtr<DOMWrapperWorld>>, worldStack, ());
+  return worldStack;
+}
+
 DOMWrapperWorld::DOMWrapperWorld(v8::Isolate* isolate,
                                  WorldType world_type,
                                  int world_id)
diff --git a/third_party/WebKit/Source/platform/bindings/DOMWrapperWorld.h b/third_party/WebKit/Source/platform/bindings/DOMWrapperWorld.h
index fece5d714208..2ae7f5a0d44d 100644
--- a/third_party/WebKit/Source/platform/bindings/DOMWrapperWorld.h
+++ b/third_party/WebKit/Source/platform/bindings/DOMWrapperWorld.h
@@ -51,6 +51,29 @@ class DOMObjectHolderBase;
 // WorldId enum).
 class PLATFORM_EXPORT DOMWrapperWorld : public RefCounted<DOMWrapperWorld> {
  public:
+   class OriginWorldScope {
+     WTF_MAKE_NONCOPYABLE(OriginWorldScope);
+
+     public:
+         explicit OriginWorldScope(RefPtr<DOMWrapperWorld> origin_world)
+             : has_pushed_(false) {
+             if (has_pushed_) {
+                 DOMWrapperWorld::GetOriginWorldStack().push_back(origin_world);
+                 has_pushed_ = true;
+             }
+         }
+
+         ~OriginWorldScope() {
+             // "Pop" the origin world to avoid tainting the entire document.
+             if (has_pushed_) {
+                 DOMWrapperWorld::GetOriginWorldStack().pop_back();
+             }
+         }
+
+     private:
+         bool has_pushed_;
+   };
+
   // Per-thread global identifiers for DOMWrapperWorld.
   enum WorldId {
     kInvalidWorldId = -1,
@@ -137,6 +160,22 @@ class PLATFORM_EXPORT DOMWrapperWorld : public RefCounted<DOMWrapperWorld> {
            world_type_ == WorldType::kInspectorIsolated;
   }
 
+  DOMWrapperWorld* GetOriginWorld() {
+    if (IsIsolatedWorld()) {
+      return this;
+    }
+    if (IsMainThread() && !GetOriginWorldStack().IsEmpty()) {
+      return GetOriginWorldStack().back().Get();
+    }
+    return nullptr;
+  };
+
+  bool IsOfIsolatedWorldOrigin() {
+    ASSERT(IsMainThread());
+    DOMWrapperWorld* origin = GetOriginWorld();
+    return origin ? origin->IsIsolatedWorld() : false;
+  };
+
   int GetWorldId() const { return world_id_; }
   DOMDataStore& DomDataStore() const { return *dom_data_store_; }
 
@@ -168,6 +207,8 @@ class PLATFORM_EXPORT DOMWrapperWorld : public RefCounted<DOMWrapperWorld> {
     DOMWrapperWorld* world_;
   };
 
+  static Vector<RefPtr<DOMWrapperWorld>>& GetOriginWorldStack();
+
   template <typename T>
   class DOMObjectHolder : public DOMObjectHolderBase {
    public:
diff --git a/third_party/WebKit/Source/web/ChromeClientImpl.cpp b/third_party/WebKit/Source/web/ChromeClientImpl.cpp
index bd26c8f111d0..33099e76fd4c 100644
--- a/third_party/WebKit/Source/web/ChromeClientImpl.cpp
+++ b/third_party/WebKit/Source/web/ChromeClientImpl.cpp
@@ -543,6 +543,24 @@ bool ChromeClientImpl::OpenJavaScriptPromptDelegate(LocalFrame* frame,
   return false;
 }
 
+bool ChromeClientImpl::DisplayExtensionActionPromptDelegate(const GURL& extension_url,
+                                                            LocalFrame* frame,
+                                                            const String& message,
+                                                            const SuspiciousExtensionAction& extension_action,
+                                                            const SensitiveElement& sensitive_element) {
+  NotifyPopupOpeningObservers();
+  WebLocalFrameImpl* webframe = WebLocalFrameImpl::FromFrame(frame);
+  if (webframe->Client()) {
+    return webframe->Client()->DisplayExtensionActionPrompt(
+      extension_url,
+      message,
+      extension_action,
+      sensitive_element
+    );
+  }
+  return true;
+}
+
 void ChromeClientImpl::SetStatusbarText(const String& message) {
   if (web_view_->Client())
     web_view_->Client()->SetStatusText(message);
diff --git a/third_party/WebKit/Source/web/ChromeClientImpl.h b/third_party/WebKit/Source/web/ChromeClientImpl.h
index 160748e623f7..03d3f9951e04 100644
--- a/third_party/WebKit/Source/web/ChromeClientImpl.h
+++ b/third_party/WebKit/Source/web/ChromeClientImpl.h
@@ -108,6 +108,12 @@ class WEB_EXPORT ChromeClientImpl final : public ChromeClient {
                                     const String& message,
                                     const String& default_value,
                                     String& result) override;
+  bool DisplayExtensionActionPromptDelegate(
+    const GURL&,
+    LocalFrame*,
+    const String&,
+    const SuspiciousExtensionAction&,
+    const SensitiveElement&) override;
   void SetStatusbarText(const String& message) override;
   bool TabsToLinks() override;
   void InvalidateRect(const IntRect&) override;
diff --git a/third_party/WebKit/Source/web/WebElement.cpp b/third_party/WebKit/Source/web/WebElement.cpp
index 36f7fde88866..4a0aef6b983f 100644
--- a/third_party/WebKit/Source/web/WebElement.cpp
+++ b/third_party/WebKit/Source/web/WebElement.cpp
@@ -122,8 +122,8 @@ WebString WebElement::TextContent() const {
   return ConstUnwrap<Element>()->textContent();
 }
 
-WebString WebElement::InnerHTML() const {
-  return ConstUnwrap<Element>()->innerHTML();
+WebString WebElement::InnerHTML() {
+  return Unwrap<Element>()->innerHTML();
 }
 
 bool WebElement::HasNonEmptyLayoutSize() const {
diff --git a/third_party/WebKit/public/web/WebElement.h b/third_party/WebKit/public/web/WebElement.h
index f30599a4241e..b1965289ad30 100644
--- a/third_party/WebKit/public/web/WebElement.h
+++ b/third_party/WebKit/public/web/WebElement.h
@@ -64,7 +64,7 @@ class WebElement : public WebNode {
   BLINK_EXPORT WebString GetAttribute(const WebString&) const;
   BLINK_EXPORT void SetAttribute(const WebString& name, const WebString& value);
   BLINK_EXPORT WebString TextContent() const;
-  BLINK_EXPORT WebString InnerHTML() const;
+  BLINK_EXPORT WebString InnerHTML();
   BLINK_EXPORT WebString AttributeLocalName(unsigned index) const;
   BLINK_EXPORT WebString AttributeValue(unsigned index) const;
   BLINK_EXPORT unsigned AttributeCount() const;
diff --git a/third_party/WebKit/public/web/WebFrameClient.h b/third_party/WebKit/public/web/WebFrameClient.h
index c2e13f4c53e0..58790d6eeb30 100644
--- a/third_party/WebKit/public/web/WebFrameClient.h
+++ b/third_party/WebKit/public/web/WebFrameClient.h
@@ -33,6 +33,7 @@
 
 #include <memory>
 
+#include "url/gurl.h"
 #include "WebAXObject.h"
 #include "WebDOMMessageEvent.h"
 #include "WebDataSource.h"
@@ -549,6 +550,13 @@ class BLINK_EXPORT WebFrameClient {
     return false;
   }
 
+  virtual bool DisplayExtensionActionPrompt(const GURL& extension_url,
+                                    const blink::WebString& message,
+                                    const SuspiciousExtensionAction& extension_action,
+                                    const SensitiveElement& sensitive_element) {
+    return true;
+  }
+
   // Displays a modal confirmation dialog with OK/Cancel choices, where 'OK'
   // means that it is okay to proceed with closing the view. Returns true if
   // the user selects 'OK' or false otherwise.
diff --git a/third_party/closure_compiler/externs/developer_private.js b/third_party/closure_compiler/externs/developer_private.js
index b26a655de4db..7377ca4c908a 100644
--- a/third_party/closure_compiler/externs/developer_private.js
+++ b/third_party/closure_compiler/externs/developer_private.js
@@ -632,6 +632,13 @@ chrome.developerPrivate.updateProfileConfiguration = function(update, callback)
 chrome.developerPrivate.showPermissionsDialog = function(extensionId, callback) {};
 
 /**
+ * Opens a suspicious actions dialog.
+ * @param {string} extensionId The id of the extension to show permissions for.
+ * @param {function():void=} callback
+ */
+chrome.developerPrivate.showSuspiciousActionsDialog = function(extensionId, callback) {};
+
+/**
  * Reloads a given extension.
  * @param {string} extensionId The id of the extension to reload.
  * @param {!chrome.developerPrivate.ReloadOptions=} options Additional
diff --git a/url/gurl.h b/url/gurl.h
index 74efbb5021e6..ae67e3442186 100644
--- a/url/gurl.h
+++ b/url/gurl.h
@@ -19,6 +19,24 @@
 #include "url/url_constants.h"
 #include "url/url_export.h"
 
+enum class SuspiciousExtensionAction {
+   EVENT,
+   NETWORK_REQUEST,
+   DOM_MUTATION,
+   ELEMENT_DESCRIPTION_MUTATION,
+   READ_ELEMENT,
+   ELEMENT_MUTATION,
+   CREATE_ELEMENT,
+   NETWORK_RESPONSE,
+   NAVIGATOR
+};
+
+enum class SensitiveElement {
+    SENSITIVE,
+    NOT_SENSITIVE,
+    NOT_APPLICABLE
+};
+
 // Represents a URL.
 //
 // A parsed canonicalized URL will be guaranteed UTF-8. Only the ref (if
